-- coding: utf-8
--------------------------------------------------------------------------------------------------------------
-- WoWMap-POI
--   a WoWMap addition
--
-- written by McBen and Lestat
-- requires WoWMap !
--------------------------------------------------------------------------------------------------------------
local WoWMapPOI={}
_G.WoWMapPOI = WoWMapPOI

WoWMap = WoWMap or {} -- prevent errors of WoWMap isn't installed


-- load locales
local function Init()
    local func, err = loadfile("Interface/Addons/wowmap-poi/locales/"..string.sub(GetLanguage(),1,2)..".lua")
    if err then
        func, err = loadfile("Interface/Addons/wowmap-poi/locales/en.lua")
    end
    if not err then
        func()
    else
        WoWMapPOI.Text={} --  the final fallback
    end
end
Init()

----- WoWMap Hooks-----------------
WoWMapPOI.ori_WoWMapOnClick = WoWMap.OnClick
local isContextMenuClick = WoWMap.isContextMenuClick or IsShiftKeyDown
function WoWMap.OnClick(this, key)

    if isContextMenuClick() then
        WoWMap.OnClick_orig(this, key)
        WoWMapPOI.ModifyContextMenu(WorldMapIconMenu)
        return
    end

    if WoWMapPOI.ClickedOnCustomIcon() then
        WoWMapPOI.EditPOI( WoWMap.Data.CurrentIcon )
        return
    end

    if IsCtrlKeyDown() or IsAltKeyDown() then

        local x,y = GetCursorPos()
        local _x,_y = WorldMapViewFrame:GetPos()
        local _w,_h = WorldMapViewFrame:GetRealSize()
        x = ( x - _x ) / _w
        y = ( y - _y ) / _h

        local m = WoWMap.GetCurrentMapID()
        if m and x >= 0 and x <= 1 and y >= 0 and y <= 1 then
            WoWMapPOI.CreateNewPOI(m,x,y)
        end
        return
    end


    WoWMapPOI.ori_WoWMapOnClick(this, key)
end

----- Events ----------
function WoWMapPOI.OnLoad(this)
    this:RegisterEvent("VARIABLES_LOADED")
    this:RegisterEvent("TB_UPDATE")
end

function WoWMapPOI.OnEvent(event)
    if WoWMapPOI[event] then WoWMapPOI[event]() end
end

function WoWMapPOI.OnHide()
    WoWMapPOIFrame:Hide()
end

local TransportBook

local function RegisterPOIs()
    -- Custom nodes
    WoWMapPOI.CustomNodes.maps=WoWMapPOI_Nodes
    WoWMapPOI.CleanUpCustomNodes()
    WoWMap.RegisterPOIs(WoWMapPOI.CustomNodes)

    -- Transport map
    TransportBook = WoWMap.RegisterPOIs(WoWMapPOI.TransportBook)
    WoWMapPOI.CollectTransportPOIs()

    -- standard
    WoWMap.RegisterPOIs(WoWMapPOI.Portal)
    WoWMap.RegisterPOIs(WoWMapPOI.MailBoxes)
    WoWMap.RegisterPOIs(WoWMapPOI.ResurrectionStone)
    WoWMap.RegisterPOIs(WoWMapPOI.Housemaid)
    WoWMap.RegisterPOIs(WoWMapPOI.Bank)
    WoWMap.RegisterPOIs(WoWMapPOI.AuctionHouse)
    WoWMap.RegisterPOIs(WoWMapPOI.Tailor)
    WoWMap.RegisterPOIs(WoWMapPOI.Alchemy)
    WoWMap.RegisterPOIs(WoWMapPOI.Weapon)
    WoWMap.RegisterPOIs(WoWMapPOI.Cooking)
    WoWMap.RegisterPOIs(WoWMapPOI.Armor)
    WoWMap.RegisterPOIs(WoWMapPOI.Woodwork)
    WoWMap.RegisterPOIs(WoWMapPOI.Gather)
    WoWMap.RegisterPOIs(WoWMapPOI.StableMaster)
    WoWMap.RegisterPOIs(WoWMapPOI.PetVendor)
    WoWMap.RegisterPOIs(WoWMapPOI.Refining)
    WoWMap.RegisterPOIs(WoWMapPOI.BulletinBoard)
    WoWMap.RegisterPOIs(WoWMapPOI.BulletinBoardRed)
    WoWMap.RegisterPOIs(WoWMapPOI.PhiriusShop)
end

function WoWMapPOI.VARIABLES_LOADED()

    SaveVariables("WoWMapPOI_Nodes")

    if not WoWMap.RegisterPOIs then
        StaticPopupDialogs["NO_WOWMAP"] = {
            text = "WoWMAP not found\n"..
            "|cffff0000WoWMap-POI requires WoWMap v4+ !!",
            button1 = TEXT("OK"),
        }
        StaticPopup_Show("NO_WOWMAP")
        return
    end

    RegisterPOIs()
end


--- Daily-Quest NPCs (taken from DailyNotes)
--@DN-QUEST-NPCS@
local DN_Npc={101772,110583,110584,110585,110711,110729,110789,110806,110969,111088,111230,111296,111382,111383,111385,111386,111387,111443,111587,111640,
  111730,112262,112264,112510,112516,112562,112610,112611,112613,112615,112616,112623,112680,112794,112847,112886,112950,113037,113038,113039,
  113046,113062,113063,113064,113068,113069,113070,113077,113082,113083,113084,113085,113170,113177,113178,113180,113278,113325,113326,113328,
  113475,113476,113477,113478,113479,113481,113482,113483,113500,113689,114087,114417,114418,114419,114420,114421,114423,114424,114425,114426,
  114744,114755,114930,115027,115028,115036,115037,115038,115039,115040,115041,115042,115300,115399,115610,115611,115612,115613,115614,116146,
  116147,116148,116149,116150,116151,116152,116153,116398,116484,116487,116530,116608,116640,116648,116740,116760,116834,116932,116978,116990,
  116993,117003,117017,117018,117055,117092,117188,117215,117264,117281,117376,117378,117379,117380,117381,117383,117384,117386,117388,117410,
  117420,117495,117497,117517,117519,117521,117522,117523,117524,117525,117532,117585,117586,117587,117588,117589,117590,117609,117639,117641,
  117751,117776,117782,118014,118056,118057,118058,118059,118060,118061,118062,118064,118065,118066,118067,118068,118069,118070,118071,118072,
  118204,118257,118274,118290,118293,118301,118315,118319,118324,118325,118328,118333,118339,118371,118377,118464,118478,118537,118597,118608,
  118755,118801,118906,118907,118908,118980,118981,119045,119048,119053,119055,119059,119064,119065,119076,119081,119111,119120,119131,119132,
  119133,119134,119149,119153,119157,119168,119190,119191,119192,119193,119230,119231,119233,119234,119235,119236,119237,119238,119241,119360,
  119362,119363,119364,119449,119494,119605,119606,119616,119617,119618,119625,119627,119631,119634,119635,119646,119647,119650,119652,119653,
  119656,119664,119666,119680,119682,119721,119722,119725,119727,119730,119731,119732,119733,119856,119857,119858,119860,119862,119871,119872,
  119873,119923,119928,119934,119946,120042,120071,120072,120073,120273,120280,120281,120284,120441,120445,120446,120447,120449,120451,120455,
  120456,120457,120458,120489,120492,120496,120518,120520,120521,120562,120563,120564,120565,120574,120575,120577,120578,120579,120581,120605,
  120606,120634,120649,120673,120678,120700,120709,120714,120717,120722,120736,120762,120771,120790,120792,120842,120968,120979,121000,121027,
  121068,121120,121122,121123,121124,121133,121142,121173,121210,121211,121212,121214,121215,121217,121297,121323,121380,121390,121391,121419,
  121428,121584,121585,121589,121592,121595,121603,121667,121668,121687,121691,121786,121787,121788,121793,121819,121820,121843,121844,121874,
  121875,121876,121888,121921,121947,121948,121949,121951,121952,121953,121956,121957,121958,121971,}
local DN_Npc_public={118905,119052,119053,119054,119055,119057,119060,119061,119063,119065,119111,119122,119158,119160,119197,119199,119201,119202,119213,119214,
  119215,119230,119231,119233,119234,119235,119236,119237,119238,119241,119360,119363,119416,119417,119418,119419,119605,119606,119616,119617,
  119618,119625,119627,119631,119634,119635,119646,119647,119650,119652,119653,119656,119664,119666,119680,119682,119726,119727,119730,119731,
  119732,119733,119856,119857,119858,119860,119862,119871,119872,119873,119917,119923,119928,119934,119946,119950,119951,120042,120071,120072,
  120073,120273,120276,120277,120280,120281,120284,120489,120492,120496,120518,120520,120521,120562,120563,120564,120565,120574,120575,120577,
  120578,120579,120581,120605,120606,120634,120649,120673,120678,120700,120709,120714,120717,120722,120736,120762,120771,120790,120792,120842,
  120979,121000,121027,121068,121120,121121,121122,121123,121124,121133,121142,121173,121210,121211,121212,121214,121215,121217,121297,121323,
  121391,121419,121428,121584,121585,121589,121592,121603,121667,121687,121691,121786,121787,121788,121793,121819,121820,121843,121844,121874,
  121875,121876,121888,121921,121947,121948,121949,121951,121952,121953,121956,121957,121958,121971,}
--@END-DN-QUEST-NPCS@
function WoWMapPOI.GetListOfQuestGivers()
    return DN_Npc,DN_Npc_public
end

-- deprecated .. not used in wowmap 5.0.3.1+
function binarySearch(list,value)
    local low = 1
    local high = #list
    local mid = 0
    while low <= high do
        mid = math.floor((low+high)/2)
        assert(list[mid],tostring(mid))
        if list[mid] > value then high = mid - 1
        else if list[mid] < value then low = mid + 1
             else return mid
             end
        end
    end
end

-- deprecated .. not used in wowmap 5.0.3.1+
function WoWMapPOI.IsNPCDailyQuestGiver(npc_id)
    if binarySearch(DN_Npc,npc_id) then return 1 end
    if binarySearch(DN_Npc_public,npc_id) then return 2 end
end

-----------------------------
WoWMapPOI.TransportBook = {
    name=TEXT(TB_TITLE),
    category=WoWMapPOI.Text.CatTransport,
    textures={  {"interface/addons/wowmap-poi/images/obj_icon.dds", 78/128, 0,104/128,26/64},
            },
    size={16,16},
    priority=100,
    maps={}
}

function WoWMapPOI.TB_UPDATE()
    WoWMapPOI.UpdateTransportPOIs()
end

function WoWMapPOI.UpdateTransportPOIs()
    WoWMapPOI.CollectTransportPOIs()
    WoWMap.ShowPOIs()
end

function WoWMapPOI.FindMapID(name)
    for id,_ in pairs(WoWMap.MapData.ZoomOutTable) do
        if name == GetZoneLocalName(id) then
            return id
        end
    end
end

function WoWMapPOI.CollectTransportPOIs()

    TransportBook.maps={}

    for i=1,TB_MAX_BOOKMARK do
        local IconType,note,_,_,_,_,tname,_=TB_GetTeleportInfo(i)
        if IconType ~= 0 then

            local name,_x,_y = string.match(tname,"^(.-)%s*%((%d+%.%d*)%s*,%s*(%d+%.%d*)%)$")

            thismap = WoWMapPOI.FindMapID(name)
            if name and thismap then
                -- TODO: add support of upper maps
                TransportBook.maps[thismap] = TransportBook.maps[thismap] or {}
                table.insert(TransportBook.maps[thismap], {x=_x/100,y=_y/100,tip=TEXT(TB_TITLE).."\n"..tname.."\n"..note,TBNr=i})
            else
                --DEFAULT_CHAT_FRAME:AddMessage("couldn't parse: "..tostring(tname)
            end
        end
    end
end

function WoWMapPOI.TransportBook.MouseClick(this,icon)
    if icon.data and icon.data.TBNr then
        WoWMapPOIDropdown.TBNr = icon.data.TBNr
        ToggleDropDownMenu( WoWMapPOIDropdown, 1, nil, "cursor", 1 ,1 )
        return true
    end
end


function WoWMapPOIDropdown_Show(this)

    if not WoWMapPOIDropdown.TBNr then return end


	local info = {}
	if UIDROPDOWNMENU_MENU_LEVEL == 1 then

        local saveItem,useItem1,useItem2,useItem3=TB_GetTeleportItem()

        info = {}
        info.text   = TEXT("TB_EDITNOTE_TIP")
        info.func = function ()
                TeleportBook.select = WoWMapPOIDropdown.TBNr
                TB_EditNote_OnClick(nil)
            end
        UIDropDownMenu_AddButton( info, 1 )

        info = {}
        info.text   = TEXT("TB_DELETE_TIP")
        info.hasArrow = 1
        UIDropDownMenu_AddButton( info, 1 )

        info = {}
        info.text = string.match(TB_TELEPORT_TIP, "^(.-)\n") or TB_TELEPORT_TIP
        local msg=string.format(TB_TELEPORT_TIP,TB_GetItemName(2))
        info.tooltipTitle= msg
        info.tooltipText= msg
        info.disabled = 1
        if useItem1 then info.disabled = nil end
        info.func = function ()
            TB_Teleport(0,WoWMapPOIDropdown.TBNr)
            HideUIPanel( WorldMapFrame )
        end
        UIDropDownMenu_AddButton( info, 1 )

        info = {}
        info.text = string.match(TB_GATE_TIP, "^(.-)\n") or TB_GATE_TIP
        local msg=string.format(TB_GATE_TIP,TB_GetItemName(3))
        info.tooltipTitle= msg
        info.tooltipText= msg
        info.owner = DropDownframe
        info.disabled = 1
        if useItem2 then info.disabled = nil end
        info.func = function ()
            TB_Teleport(1,WoWMapPOIDropdown.TBNr)
            HideUIPanel( WorldMapFrame )
        end
        UIDropDownMenu_AddButton( info, 1 )

        info = {}
        info.text = string.match(TB_CHANNEL_TIP, "^(.-)\n") or TB_CHANNEL_TIP
        local msg=string.format(TB_CHANNEL_TIP,TB_GetItemName(4))
        info.tooltipTitle= msg
        info.tooltipText= msg
        info.owner = DropDownframe
        info.disabled = 1
        if useItem3 then info.disabled = nil end
        info.func = function ()
            TB_Teleport(2,WoWMapPOIDropdown.TBNr)
            HideUIPanel( WorldMapFrame )
        end
        UIDropDownMenu_AddButton( info, 1 )

    elseif UIDROPDOWNMENU_MENU_LEVEL == 2 then
        info = {}
        info.text   = TEXT("TB_DELETE_TIP")
        info.func = function ()
            TB_DeleteTeleport(WoWMapPOIDropdown.TBNr)
        end
        UIDropDownMenu_AddButton( info, 2 )
    end
end
